#define kFailedToLoadDLLError     1
#define kCouldNotFindFunction     1

static HINSTANCE DLLHandle;      
short  linkaddr=0x150;			        /* Hardware Adresse der ADwin-Karte */
long   message=1;						/* Fehlermeldungen aus der DLL ein(1)/aus(0) */


/* Variablendeklaration, die den Adressbereich eines Funktionspointers enthlt */
static long 	(*ADboot_Ptr)(char *dateiname, short linkaddresse, long iboardsize, short msgbox);
static short 	(*ADBload_Ptr)(char *dateiname, short linkaddresse, short msgbox);
static short 	(*ADTest_Version_Ptr)(short linkaddresse, short msgbox);
static short 	(*ADProzessorTyp_Ptr)(short linkaddresse);
static short 	(*AD_Auslastung_Ptr)(short linkaddresse);
static long 	(*AD_Memory_Ptr)(short linkaddresse);
static long 	(*AD_Memory_all_Ptr)(short typ, short linkaddresse);
static short 	(*Get_ADC_Ptr)(short nadc, short linkaddresse);
static short 	(*Set_DAC_Ptr)(short ndac, short iw, short linkaddresse);
static short 	(*Set_Digout_Ptr)(short iw, short linkaddresse);
static long 	(*Get_Digout_Ptr)(short linkaddresse);
static long 	(*Get_Digin_Ptr)(short linkaddresse);
static short 	(*Set_DigoutX_Ptr)(short iw, short linkaddresse);
static long 	(*Get_DigoutX_Ptr)(short linkaddresse);
static long 	(*Get_DiginX_Ptr)(short linkaddresse);
static short 	(*ADB_Start_Ptr)(short np, short linkaddresse);
static short 	(*ADB_Stop_Ptr)(short np, short linkaddresse);
static short 	(*Set_ADBPar_Ptr)(short np, long iw, short linkaddresse);
static short 	(*Set_ADBFPar_Ptr)(short np, float fw, short linkaddresse);
static long 	(*Get_ADBPar_Ptr)(short np, short linkaddresse);
static float 	(*Get_ADBFPar_Ptr)(short np, short linkaddresse);
static long 	(*Get_Data_Length_Ptr)(short nr, short linkaddresse);
static short 	(*Get_Data_Ptr)(void *tarr, short typ, short nadc, long lstart, long il, short linkaddresse);
static short 	(*Set_Data_Ptr)(void *tarr, short typ, short nadc, long lstart, long il, short linkaddresse);
static short 	(*SaveFast_Ptr)(char *dateiname, short nr, long lstart, long il, short mode, short linkaddresse);
static long 	(*Get_Fifo_Count_Ptr)(short nadc, short linkaddresse);
static long 	(*Get_Fifo_Empty_Ptr)(short nadc, short linkaddresse);
static short 	(*Clear_Fifo_Ptr)(short nadc, short linkaddresse);
static short 	(*Get_Fifo_Ptr)(void *tarr, short typ, short nadc, long il, short linkaddresse);
static short 	(*Set_Fifo_Ptr)(void *tarr, short typ, short nadc, long il, short linkaddresse);
static long  	(*AD_Net_Connect_Ptr)(char *prot, char *addr, char *EPoint, char *PWord, long msg);
static long  	(*AD_Net_Disconnect_Ptr);


/* Laden der DLL und Funktionsaddresse ermitteln */
static int LoadDLLIfNeeded(void)
{
    if (DLLHandle)
        return 0;

    DLLHandle = LoadLibrary("adwin32.dll");
    if (DLLHandle == NULL) {
        return kFailedToLoadDLLError;
        }

    if (!(ADboot_Ptr = (void*) GetProcAddress(DLLHandle, "ADboot")))
        goto FunctionNotFoundError;

    if (!(ADBload_Ptr = (void*) GetProcAddress(DLLHandle, "ADBload")))
        goto FunctionNotFoundError;

    if (!(ADTest_Version_Ptr = (void*) GetProcAddress(DLLHandle, "ADTest_Version")))
        goto FunctionNotFoundError;

    if (!(ADProzessorTyp_Ptr = (void*) GetProcAddress(DLLHandle, "ADProzessorTyp")))
        goto FunctionNotFoundError;

    if (!(AD_Auslastung_Ptr = (void*) GetProcAddress(DLLHandle, "AD_Auslastung")))
        goto FunctionNotFoundError;

    if (!(AD_Memory_Ptr = (void*) GetProcAddress(DLLHandle, "AD_Memory")))
        goto FunctionNotFoundError;

    if (!(AD_Memory_all_Ptr = (void*) GetProcAddress(DLLHandle, "AD_Memory_all")))
        goto FunctionNotFoundError;

    if (!(Get_ADC_Ptr = (void*) GetProcAddress(DLLHandle, "Get_ADC")))
        goto FunctionNotFoundError;

    if (!(Set_DAC_Ptr = (void*) GetProcAddress(DLLHandle, "Set_DAC")))
        goto FunctionNotFoundError;

    if (!(Set_Digout_Ptr = (void*) GetProcAddress(DLLHandle, "Set_Digout")))
        goto FunctionNotFoundError;

    if (!(Get_Digout_Ptr = (void*) GetProcAddress(DLLHandle, "Get_Digout")))
        goto FunctionNotFoundError;

    if (!(Get_Digin_Ptr = (void*) GetProcAddress(DLLHandle, "Get_Digin")))
        goto FunctionNotFoundError;

    if (!(Set_DigoutX_Ptr = (void*) GetProcAddress(DLLHandle, "Set_DigoutX")))
        goto FunctionNotFoundError;

    if (!(Get_DigoutX_Ptr = (void*) GetProcAddress(DLLHandle, "Get_DigoutX")))
        goto FunctionNotFoundError;

    if (!(Get_DiginX_Ptr = (void*) GetProcAddress(DLLHandle, "Get_DiginX")))
        goto FunctionNotFoundError;

    if (!(ADB_Start_Ptr = (void*) GetProcAddress(DLLHandle, "ADB_Start")))
        goto FunctionNotFoundError;

    if (!(ADB_Stop_Ptr = (void*) GetProcAddress(DLLHandle, "ADB_Stop")))
        goto FunctionNotFoundError;

    if (!(Set_ADBPar_Ptr = (void*) GetProcAddress(DLLHandle, "Set_ADBPar")))
        goto FunctionNotFoundError;

    if (!(Set_ADBFPar_Ptr = (void*) GetProcAddress(DLLHandle, "Set_ADBFPar")))
        goto FunctionNotFoundError;

    if (!(Get_ADBPar_Ptr = (void*) GetProcAddress(DLLHandle, "Get_ADBPar")))
        goto FunctionNotFoundError;

    if (!(Get_ADBFPar_Ptr = (void*) GetProcAddress(DLLHandle, "Get_ADBFPar")))
        goto FunctionNotFoundError;

    if (!(Get_Data_Length_Ptr = (void*) GetProcAddress(DLLHandle, "Get_Data_Length")))
        goto FunctionNotFoundError;

    if (!(Get_Data_Ptr = (void*) GetProcAddress(DLLHandle, "Get_Data")))
        goto FunctionNotFoundError;

    if (!(Set_Data_Ptr = (void*) GetProcAddress(DLLHandle, "Set_Data")))
        goto FunctionNotFoundError;

    if (!(SaveFast_Ptr = (void*) GetProcAddress(DLLHandle, "SaveFast")))
        goto FunctionNotFoundError;

    if (!(Get_Fifo_Count_Ptr = (void*) GetProcAddress(DLLHandle, "Get_Fifo_Count")))
        goto FunctionNotFoundError;

    if (!(Get_Fifo_Empty_Ptr = (void*) GetProcAddress(DLLHandle, "Get_Fifo_Empty")))
        goto FunctionNotFoundError;

    if (!(Clear_Fifo_Ptr = (void*) GetProcAddress(DLLHandle, "Clear_Fifo")))
        goto FunctionNotFoundError;

    if (!(Get_Fifo_Ptr = (void*) GetProcAddress(DLLHandle, "Get_Fifo")))
        goto FunctionNotFoundError;

    if (!(Set_Fifo_Ptr = (void*) GetProcAddress(DLLHandle, "Set_Fifo")))
        goto FunctionNotFoundError;

    if (!(AD_Net_Connect_Ptr = (void*) GetProcAddress(DLLHandle, "AD_Net_Connect")))
        goto FunctionNotFoundError;

    if (!(AD_Net_Disconnect_Ptr = (void*) GetProcAddress(DLLHandle, "AD_Net_Disconnect")))
        goto FunctionNotFoundError;

    return 0;


/* Fehlerbehandlung */
FunctionNotFoundError:
    FreeLibrary(DLLHandle);     /* Ensorgung der gesamten DLL */
    DLLHandle = 0;
            return kCouldNotFindFunction;
}


/* Verbindungscode fr jede DLL Funktion */

long ADboot(char *dateiname, short linkaddresse, long iboardsize, short msgbox)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*ADboot_Ptr)(dateiname, linkaddresse, iboardsize, msgbox);
}

short ADBload(char *dateiname, short linkaddresse, short msgbox)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*ADBload_Ptr)(dateiname, linkaddresse, msgbox);
}

short ADTest_Version(short linkaddresse, short msgbox)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*ADTest_Version_Ptr)(linkaddresse, msgbox);
}

short ADProzessorTyp(short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*ADProzessorTyp_Ptr)(linkaddresse);
}

short AD_Auslastung(short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*AD_Auslastung_Ptr)(linkaddresse);
}

long AD_Memory(short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*AD_Memory_Ptr)(linkaddresse);
}

long AD_Memory_all(short typ, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*AD_Memory_all_Ptr)(typ, linkaddresse);
}

short Get_ADC(short nadc, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Get_ADC_Ptr)(nadc, linkaddresse);
}

short Set_DAC(short ndac, short iw, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Set_DAC_Ptr)(ndac, iw, linkaddresse);
}

short Set_Digout(short iw, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Set_Digout_Ptr)(iw, linkaddresse);
}

long Get_Digout(short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Get_Digout_Ptr)(linkaddresse);
}

long Get_Digin(short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Get_Digin_Ptr)(linkaddresse);
}

short Set_DigoutX(short iw, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Set_DigoutX_Ptr)(iw, linkaddresse);
}

long Get_DigoutX(short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Get_DigoutX_Ptr)(linkaddresse);
}

long Get_DiginX(short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Get_DiginX_Ptr)(linkaddresse);
}

short ADB_Start(short np, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*ADB_Start_Ptr)(np, linkaddresse);
}

short ADB_Stop(short np, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*ADB_Stop_Ptr)(np, linkaddresse);
}

short Set_ADBPar(short np, long iw, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Set_ADBPar_Ptr)(np, iw, linkaddresse);
}

short Set_ADBFPar(short np, float fw, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Set_ADBFPar_Ptr)(np, fw, linkaddresse);
}

long Get_ADBPar(short np, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Get_ADBPar_Ptr)(np, linkaddresse);
}

float Get_ADBFPar(short np, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return 1;
    return (*Get_ADBFPar_Ptr)(np, linkaddresse);
}

long Get_Data_Length(short nr, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Get_Data_Length_Ptr)(nr, linkaddresse);
}

short Get_Data(void *tarr, short typ, short nadc, long lstart, long il, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Get_Data_Ptr)(tarr, typ, nadc, lstart, il, linkaddresse);
}

short Set_Data(void *tarr, short typ, short nadc, long lstart, long il, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Set_Data_Ptr)(tarr, typ, nadc, lstart, il, linkaddresse);
}

short SaveFast(char *dateiname, short nr, long lstart, long il, short mode, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*SaveFast_Ptr)(dateiname, nr, lstart, il, mode, linkaddresse);

}

long Get_Fifo_Count(short nadc, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Get_Fifo_Count_Ptr)(nadc, linkaddresse);
}

long Get_Fifo_Empty(short nadc, short linkaddresse)
{

    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Get_Fifo_Empty_Ptr)(nadc, linkaddresse);
}

short Clear_Fifo(short nadc, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Clear_Fifo_Ptr)(nadc, linkaddresse);
}

short Get_Fifo(void *tarr, short typ, short nadc, long il, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Get_Fifo_Ptr)(tarr, typ, nadc, il, linkaddresse);
}

short Set_Fifo(void *tarr, short typ, short nadc, long il, short linkaddresse)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*Set_Fifo_Ptr)(tarr, typ, nadc, il, linkaddresse);
}

long AD_Net_Connect(char *prot, char *addr, char *EPoint, char *PWord, long msg)
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*AD_Net_Connect_Ptr)(prot, addr, EPoint, PWord, msg);
}

long AD_Net_Disconnect()
{
    int dllLoadError;
    if (dllLoadError = LoadDLLIfNeeded())
        return dllLoadError;
    return (*AD_Net_Disconnect_Ptr);
}




/* Den analogen Eingang "nr" messen und das Ergebnis zurckgeben                 */
/* ==============================================================================*/
short  ADC(short nr)
{
  return (Get_ADC(nr, linkaddr));   /* Messergebnis abholen */
}

/* Liefert die momentane Auslastung des Transputers                              */
/* ===================================================================MH=01=96===*/
short  Auslast()
{
  return (AD_Auslastung(linkaddr));          /* Ergebnis abholen */
}

/* Abfragen der digitalen Eingnge. Die Eingnge stehen bitweise in einem 16-Bit Wort*/
/* =======================================================================MH=01=96===*/
long  DigIn()
{
  return (Get_Digin(linkaddr));           /* Ergebnis abholen */
}

/* Rcklesen des auf den digitalen Ausgngen ausgegebenen Wertes                 */
/* ===================================================================MH=01=96===*/
long  DigOut()
{
  return (Get_Digout(linkaddr));          /* Ergebnis abholen */
}

/* Liefert den momentanen freien Speicher des Transputers (Ergebnis in Bytes)    */
/* ===================================================================MH=01=96===*/
long  Freemem()
{
  return (AD_Memory(linkaddr));          /* Ergebnis abholen */
}

/* Liefert den momentanen freien Speicher des Transputers (Ergebnis in Bytes)    */
/* ===================================================================MH=01=96===*/
long  Freemem_T9(short typ)
{
  long mul=4;
  if (typ==1) mul=6;
  return (AD_Memory_all(typ, linkaddr)*mul);          /* Ergebnis abholen */
}

/* ADbasic ACTIVATE_PC-Flag abfragen und das Ergebnis zurckgeben                */
/* ==============================================================================*/
long  GetActivate(short nr)
{
  short parno;
  long erg;

  parno = 930+nr-1000;
  erg = Get_ADBPar(parno, linkaddr);     /* Parameter holen */
  if (erg == 1) Set_ADBPar(parno, 0, linkaddr);
  return (erg);
}

/* Den analogen Ausgang "ndac" auf den Wert "iw" setzen                          */
/* ==============================================================================*/
short  SetDAC (short ndac, short iw)
{
  return (Set_DAC(ndac, iw, linkaddr));
}

/* Gibt den Wert "iw" auf den digitalen Ausgngen aus                            */
/* ===================================================================MH=01=96===*/
short  SetDigOut (short iw)
{
  return (Set_Digout(iw, linkaddr));
}

/* Einen Parameter auf der ADwin-Karte auf den Wert "il" setzen                  */
/* ==============================================================================*/
short  SetPar (short npar, long il)
{
  return (Set_ADBPar(npar, il, linkaddr));
}

/* Eine Option auf der ADwin-Karte auf den Wert "il" setzen                  */
/* ==============================================================================*/
short  SetOpt (short npar, long il)
{
  return (Set_ADBPar((npar-1000), il, linkaddr));
}

/* Einen Float Parameter auf der ADwin-Karte auf den Wert "iw" setzen            */
/* ==============================================================================*/
short  SetFPar (short npar, float iw)
{
  return (Set_ADBFPar(npar, iw, linkaddr));
}

/* Einen ADbasic Prozess auf der ADwin-Karte starten                             */
/* ==============================================================================*/
short  ADBStart (short nproz)
{
  return (ADB_Start(nproz, linkaddr));
}


/* Einen ADbasic Prozess auf der ADwin-Karte stoppen                             */
/* ==============================================================================*/
short  ADBStop (short nproz)
{
  return (ADB_Stop(nproz, linkaddr));
}


/* Einen ADbasic short Parameter von der ADwin-Karte lesen                     */
/* ==============================================================================*/
long  GetPar(short npar)
{
  return (Get_ADBPar(npar, linkaddr));            /* Parameter holen */
}

/* Eine Option von der ADwin-Karte lesen                                         */
/* ==============================================================================*/
long  GetOpt(short npar)
{
  return (Get_ADBPar((npar-1000), linkaddr));            /* Parameter holen */
}

/* Einen short Parameter von der ADwin-Karte lesen                             */
/* ==============================================================================*/
float  GetFPar(short npar)
{
  return (Get_ADBFPar(npar, linkaddr));            /* Parameter holen */
}

/* Element/e aus einem ADbasic Datensatz vom Transputer holen.
            bergabe in short ARRAY*/
/* ==============================================================================*/
short  GetData(short ndata, long nstart, long il, short iw[])
{
  return (Get_Data(iw, 1, ndata, nstart, il, linkaddr));
}

/* Element/e aus einem ADbasic Datensatz vom Transputer holen.
            bergabe in long ARRAY*/
/* ==============================================================================*/
short  GetlData(short ndata, long nstart, long il, long iw[])
{
  return (Get_Data(iw, 2, ndata, nstart, il, linkaddr));
}

/* Element/e aus einem ADbasic Datensatz vom Transputer holen.
            bergabe in Float ARRAY*/
/* ==============================================================================*/
short  GetfData(short ndata, long nstart, long il, float iw[])
{
  return (Get_Data(iw, 5, ndata, nstart, il, linkaddr));
}

/* Einem ADbasic Datensatz die Werte aus einem short ARRAY zuweisen*/
/* ==============================================================================*/
short  SetData(short ndata, long nstart, long il, short iw[])
{
  return (Set_Data(iw, 1, ndata, nstart, il, linkaddr));
}


/* Einem ADbasic Datensatz die Werte aus einem long ARRAY zuweisen*/
/* ==============================================================================*/
short  SetlData(short ndata, long nstart, long il, long iw[])
{
  return (Set_Data(iw, 2, ndata, nstart, il, linkaddr));
}

/* Einem ADbasic Datensatz die Werte aus einem Float ARRAY zuweisen*/
/* ==============================================================================*/
short  SetfData(short ndata, long nstart, long il, float iw[])
{
  return (Set_Data(iw, 5, ndata, nstart, il, linkaddr));
}


/* Schreibt die gewhlten Elemente eines ADBasic DATA arrays direkt auf die Festplatte*/
/* ==============================================================================*/
short Data2File(char *dateiname, short nr, long lstart, long il, short mode)
{
  return SaveFast(dateiname, nr, lstart, il, mode,linkaddr);
}


/* Anzahl der Elemente im FIFO ermitteln                                         */
/* ==============================================================================*/
long  GetFifoCount(short nfifo)
{
  return (Get_Fifo_Count(nfifo, linkaddr));
}

/* Anzahl der freien Positionen im FIFO ermitteln                                         */
/* ==============================================================================*/
long  GetFifoEmpty(short nfifo)
{
  return (Get_Fifo_Empty(nfifo, linkaddr));
}

/* Inhalt des FIFO lschen                                                       */
/* ==============================================================================*/
short  ClearFifo (short nfifo)
{
  return (Clear_Fifo(nfifo, linkaddr));
}

/* Element/e aus einem FIFO vom Transputer holen.
            bergabe in short ARRAY*/
/* ==============================================================================*/
short  GetFifo(short nfifo, long il, short iw[])
{
  return (Get_Fifo(iw, 1, nfifo, il, linkaddr));
}

/* Element/e aus einem FIFO vom Transputer holen.
            bergabe in long ARRAY*/
/* ==============================================================================*/
short  GetlFifo(short nfifo, long il, long iw[])
{
  return (Get_Fifo(iw, 2, nfifo, il, linkaddr));
}

/* Element/e aus einem FIFO vom Transputer holen.
            bergabe in Float ARRAY*/
/* ==============================================================================*/
short  GetfFifo(short nfifo, long il, float iw[])
{
  return (Get_Fifo(iw, 5, nfifo, il, linkaddr));
}

/* Einem ADbasic FIFO die Werte aus einem short ARRAY zuweisen*/
/* ==============================================================================*/
short  SetFifo(short nfifo, long il, short iw[])
{
  return (Set_Fifo(iw, 1, nfifo, il, linkaddr));
}

/* Einem ADbasic FIFO die Werte aus einem long ARRAY zuweisen*/
/* ==============================================================================*/
short  SetlFifo(short nfifo, long il, long iw[])
{
  return (Set_Fifo(iw, 2, nfifo, il, linkaddr));
}

/* Einem ADbasic FIFO die Werte aus einem Float ARRAY zuweisen*/
/* ==============================================================================*/
short  SetfFifo(short nfifo, long il, float iw[])
{
  return (Set_Fifo(iw, 5, nfifo, il, linkaddr));
}

/* Ld einen ADbasic Prozess auf die ADwin-Karte*/
/* ==============================================================================*/
short  ADBPrLoad(char  *dateiname)
{
  return (ADBload(dateiname, linkaddr, message));                /* Laden */
}

/* Ld den Treiber der ADwin-Karte*/
/* ==============================================================================*/
long  Iserv(char  *dateiname, long IboardSize)
{
  return (ADboot(dateiname, linkaddr, IboardSize, message));     /* ADwin Karte booten */
}

/* Ld den Treiber der ADwin-Karte*/
/* ==============================================================================*/
long FAR PASCAL Boot(char *dateiname, long IboardSize)
{
  return (Iserv(dateiname, IboardSize));     /* ADwin Karte booten */
}

/* Testet, ob Transputer vorhanden und richtig initialisiert ist */
/* ==============================================================================*/
short  Test()
{
  return (ADTest_Version(linkaddr, message));
}

/* Fehlermeldungen bei Iserv, ADPrLoad u. Test unterdrcken(state=0) o. zulassen(state=1) */
/* ==============================================================================*/
void  ErrMessage(short state)
{
  message=state;
}

/* Baut ber Netzwerk eine Verbindung zu einem Rechner auf, an dem ein ADwin-System angeschlossen ist */
/* Auf dem Rechner mit dem ADwin-System mu das Programm ADserver.exe laufen, welches im Lieferumfang */
/* von ADbasic enthalten ist.                                                                         */ 
/* ===================================================================================================*/
long Net_Connect(char *prot, char *addr, char *EPoint, char *PWord)
{
  return (AD_Net_Connect(prot, addr, EPoint, PWord, message));
}

/* Beendet die Verbindung die ber Net_Connect aufgebaut wurde                 */
/* ============================================================================*/
long Net_Disconnect()
{
  return (AD_Net_Disconnect());
}

